/// <reference types="cypress" />
describe('Ticket descriptor', () => {
    const toCloneOpt = '[role="menu"] .q-list > :nth-child(5)';
    const setWeightOpt = '[role="menu"] .q-list > :nth-child(6)';
    const warehouseValue = ':nth-child(1) > :nth-child(6) > .value > span';
    const summaryHeader = '.summaryHeader > div';
    const weight = 25;
    const ticketId = 1;

    beforeEach(() => {
        cy.login('developer');
        cy.visit(`/#/ticket/${ticketId}/summary`);
    });

    it('should clone the ticket without warehouse', () => {
        cy.openLeftMenu();
        cy.openActionsDescriptor();
        cy.get(toCloneOpt).click();
        cy.clickConfirm();
        cy.get(warehouseValue).contains('Warehouse One');
        cy.get(summaryHeader)
            .invoke('text')
            .then((text) => {
                const [, owner] = text.split('-');
                cy.wrap(owner.trim()).should('eq', 'Bruce Wayne (1101)');
            });
    });

    it('should set the weight of the ticket', () => {
        cy.openLeftMenu();
        cy.openActionsDescriptor();
        cy.get(setWeightOpt).click();
        cy.get('.q-dialog input').type(25);
        cy.clickConfirm();

        cy.get('.q-notification').should('contain', 'Peso establecido');

        cy.intercept('POST', /\/api\/Tickets\/\d+/).as('worker');
        cy.wait('@worker').then(() =>
            cy.get(descriptorTitle).should('include.text', 'Jessica')
        );

        cy.get('@fetchSpy').should('have.been.called');
    });
});
